<?php

class ThumbSniper_Premium extends ThumbSniper
{

	protected $options;



	function ThumbSniper_Premium()
	{
		$this->__construct();
	} // function



	function __construct()
	{
		$this->options = new ThumbSniper_Premium_Options;
		ThumbSniper::init();
		$this->init();
	} // function



	function admin_init()
	{

	} // function



	function init()
	{
		add_action(
			$tag = 'plugins_loaded',
			$function_to_add = array( &$this, 'add_premium_plugin' )
			);
	} // function



	function add_premium_plugin()
	{
		if( !is_admin() )
		{
			add_action(
				$tag = 'wp_footer',
				$function_to_add = array( &$this, 'thumbsniper_premium_scripts' )
			);			
		}
	} // function



	function convert_line_breaks($string, $line_break=PHP_EOL) {
		$patterns = array("/(<br>|<br \/>|<br\/>)\s*/i", "/(\r\n|\r|\n)/");
		$replacements = array(PHP_EOL, $line_break);
		$string = preg_replace($patterns, $replacements, $string);

		return $string;
	}



	function thumbsniper_premium_scripts() 
	{
		$out = "\n<!-- ThumbSniper premium scripts - start -->\n";

		global $post;

		if( !isset($post) || get_post_meta($post->ID, 'thumbsniper_hide', true ) == "" )
		{
			$size = $this->options->get_image_size();
			$imageWidth = $size['w'] + 15;
			$imageHeight = $size['h'] + 7;

			switch( $this->options->get_general_setting( "thumbsniper_position" ) )
                        {
                                case "above":
                                        $positionMy = "bottom center";
                                        $positionAt = "top center";
                                        break;
                                case "below":
                                        $positionMy = "top center";
                                        $positionAt = "bottom center";
                                        break;
                                case "left":
                                        $positionMy = "right center";
                                        $positionAt = "left center";
                                        break;
                                case "right":
                                        $positionMy = "left center";
                                        $positionAt = "right center";
                                        break;
                                default:
                                        $positionMy = "top center";
                                        $positionAt = "bottom center";
                        }

                        $out.= "<script type=\"text/javascript\">\n";

			if( $this->options->get_general_setting( 'thumbsniper_jquery_noconflict' ) == "yes" )
                        {
				$out.= 'var ThumbSniperPremium = jQuery.noConflict();';
				$jQueryName = "ThumbSniperPremium";
			}else
			{
				$jQueryName = "jQuery";
			}

			$out.= $jQueryName . '(document).ready(function() {' . $jQueryName . '(function() {';

			$premiumWidth = 240;
			$premiumWidthFull = $imageWidth + $premiumWidth + 80;

			$out.= 'var imageWidth = ' . $imageWidth . ';';
			$out.= 'var imageHeight = ' . $imageHeight . ';';
			$out.= 'var premiumWidth = ' . $premiumWidth . ';';
			$out.= 'var premiumWidthFull = ' . $premiumWidthFull . ';';

			$elements = $this->options->get_advanced_thumbnails_setting('thumbsniper_advanced_thumbnails_elements');

                        $out.= "var elements = new Array();";
                        $out.= "elements[0] = new Object();";

                        foreach($elements as $element) {
                                foreach($element as $key => $value) {
                                        $out.= "elements[0]['" . $key . "'] = '" . $this->convert_line_breaks($value, "<br>") . "';";
                                }
                        }

                        $out.= $jQueryName . '(".thumbsniperpremium").live("mouseover", function(event) {
                                var ThumbSniperVersion = "' . $this->options->get_general_setting("thumbsniper") . '";
                                var ThumbSniperScaling = ' . $this->options->get_general_setting("thumbsniper_scaling") . ';
                                var PreviewType = "' . $this->options->get_general_setting("thumbsniper_preview") . '";
				var active = true;
                                var tsLink = ' . $jQueryName . '(this);

                                ' . $jQueryName . '(this).qtip({
                                        overwrite: true,
                                        content: {
                                                text: "<div class=\"thumbsniperimageholder\" style=\"min-width: " + premiumWidthFull + "px; min-height: " + imageHeight + "px;\">" +
                                                        "<div class=\"thumbsniperimageholder\" style=\"width: " + premiumWidthFull + "px; height: " + imageHeight + "px;\">" +
                                                        "<div class=\"thumbsniperinner\">" +
                                                        "<img class=\"thumbsniperinnerimg\" src=\"' . plugins_url('wait.gif', dirname(__FILE__)) . '\"></div></div></div>",
                                                ajax: {
                                                        loading: true,
                                                        url: "http://gunslinger.thumbsniper.com/fire.php",
                                                        type: "GET",
                                                        dataType: "jsonp",
                                                        data: {';
								$out.= $this->thumbsniper_json_data($jQueryName) .
                                                        '},
                                                        success: function(data, status, jqXHR) {
								if(active == true) {
	                                                                if(data.url == "wait") {
        	                                                                var self = this;
                	                                                        setTimeout(function () {
                        	                                                        self.set("content.ajax.url", "' . self::GUNSLINGER_URL . '");
                                	                                        }, 1000);
                                        	                        }else {
                                                	                                        var out = "<img src=\"" + data.url + "\">";
                                                        	                                premiumid = tsLink.attr("premiumid");
	
        	                                                                                out =
                	                                                                "<div class=\"thumbsniperimageholder\" style=\"min-width: " + premiumWidthFull + "px; min-height: " + imageHeight + "px;\">" +
                        	                                                        "<div style=\"float: left\; padding-left: 0px; padding-right: 20px; min-width: " + imageWidth + "px;\"><img src=\"" + data.url + "\"></div>" +
                                	                                                "<div class=\"thumbsniperinner\">" +
                                        	                                        "<div class=\"thumbsniperinnerimg premiumtext\" style=\"float: left\; width: 100%;\">" + elements[0][premiumid] + "</div></div></div>";

                                                	                        this.set("content.text", out);
                                                        	        }
								}
                                                        }
                                                }
                                        },
					show: {
                                                event: event.type,
                                                ready: true,
                                                solo: true,
                                                                effect: false
                                        },
					events: {
						hide: function(event, api) {
							active = false;
        					}
					},
                                        hide: {
                                        	fixed: false,
                                                effect: false
                                        },
                                        tip: {
                                                corner: true,
                                                border: 3,
                                                width: 16,
                                                height: 24
                                        },
                                        position: {
                                                my: "' . $positionMy . '",
                                                at: "' . $positionAt . '",
                                                adjust: {
                                                        method: "flip"
                                                },
                                                viewport: ' . $jQueryName . '(window),
                                                                effect: false
                                        },
                                        style: {
                                                classes: "ui-tooltip-' . $this->options->get_general_setting( 'thumbsniper_background' ) . ' ui-tooltip-shadow ui-tooltip-rounded",
                                                padding: 20';

                        $out.=       '}
                                }).removeAttr("alt").removeAttr("title");
                        });';

			$out.= '
				});
			});
			</script>';
                }

        $out.= "\n<!-- ThumbSniper premium scripts - end -->\n";
        print($out);


	} // function

} // class

?>
