<?php

class ThumbSniper_Premium_Options extends ThumbSniper_Options
{

	private $pagehook_advanced;
	private $advanced_thumbnails_settings_defaults = array();
	private $advanced_thumbnails_settings;



	function ThumbSniper_Premium_Options() 
	{
		$this->__construct();
	} // function



	function __construct()
	{
		ThumbSniper_Options::__construct();
	} // function



	function get_advanced_thumbnails_setting($arg)
	{
		if( $this->advanced_thumbnails_settings == false ) 
		{
			$this->advanced_thumbnails_settings = wp_parse_args(get_option('thumbsniper_advanced_thumbnails_settings'), $this->advanced_thumbnails_settings_defaults);
		}

		return $this->advanced_thumbnails_settings[$arg];
	} // function



	function admin_init()
	{
		ThumbSniper_Options::admin_init();

//add_settings_section('thumbsniper_advanced_thumbnails_intro', 'Introduction', 'thumbsniper_advanced_thumbnails_settings_introduction', 'thumbsniper_advanced_thumbnails');
//add_settings_section('thumbsniper_advanced_thumbnails_elements', 'Elements', 'thumbsniper_advanced_thumbnails_settings_elements', 'thumbsniper_advanced_thumbnails');

		register_setting(
			$option_group = 'thumbsniper_advanced_thumbnails_settings',
			$option_name = 'thumbsniper_advanced_thumbnails_settings',
			$sanitize_callback = array( &$this, 'advanced_thumbnails_settings_validate' )
			);

		add_settings_field(
			$id = 'thumbsniper_advanced_thumbnails_elements',
			$title = 'advanced thumbnails',
			$callback = array( &$this, 'dummy' ),
			$page = 'thumbsniper_advanced_thumbnails',
			$section = null,
			$args = null
			);

		add_settings_field(
			$id = 'thumbsniper_advanced_thumbnails_newelement',
			$title = 'add new',
			$callback = array( &$this, 'dummy' ),
			$page = 'thumbsniper_advanced_thumbnails',
			$section = null,
			$args = null
			);

	} // function



	function admin_init_menu()
	{
		ThumbSniper_Options::admin_init_menu();

		$this->pagehook_advanced = add_submenu_page(
			$parent_slug = 'thumbsniper',
			$page_title = 'Advanced thumbnails',
			$menu_title = 'Advanced thumbnails',
			$capability = 'manage_options',
			$menu_slug = 'thumbsniper_advanced_thumbnails',
			$function = array( &$this, 'advanced_settings_page' )
			);

		add_meta_box(
			$id = 'thumbsniper_elements',
			$title = 'Elements',
			$callback = array( &$this, 'advanced_thumbnails_settings_elements' ),
			$post_type = $this->pagehook_advanced,
			$context = 'normal',
			$priority = 'core'
		);
	}



	function advanced_settings_page()
	{
?>

		<script type="text/javascript">
		//<![CDATA[
			jQuery(document).ready( function($)
			{
				// close postboxes that should be closed
				$('.if-js-closed').removeClass('if-js-closed').addClass('closed');
				// postboxes setup
				postboxes.add_postbox_toggles('<?php echo $this->pagehook_advanced; ?>');
			});
		//]]>
		</script>

		<div class="wrap">
			<h2>ThumbSniper - Advanced thumbnails</h2>
			<form action="options.php" method="post">
				<div id="poststuff" class="metabox-holder has-right-sidebar">
					<div id="side-info-column" class="inner-sidebar">
						<?php do_meta_boxes($this->pagehook_advanced, 'side', NULL); ?>
					</div>
					<div id="post-body" class="has-sidebar">
						<div id="post-body-content" class="has-sidebar-content">
							<?php do_meta_boxes($this->pagehook_advanced, 'normal'); ?>
							<?php do_settings_sections('thumbsniper'); ?>
							<?php settings_fields('thumbsniper_advanced_thumbnails_settings'); ?>
							<input name="Submit" type="submit" value="<?php esc_attr_e('Save Changes'); ?>" />
							<?php wp_nonce_field('closedpostboxes', 'closedpostboxesnonce', false ); ?>
							<?php wp_nonce_field('meta-box-order', 'meta-box-order-nonce', false ); ?>
						</div>
					</div>
				</div>
			</form>
		</div>

<?php
	} // function



	function advanced_thumbnails_settings_validate($input) 
	{
		$valid = array();

		// TODO: validate

		$elements = array();
		$counter = 0;

		foreach( $input['thumbsniper_advanced_thumbnails_elements_key'] as $element ) 
		{
			$value = $input['thumbsniper_advanced_thumbnails_elements_value'][$counter];
			if( !empty($element) && !empty($value) )
			{
				$elements[] = array( $element => $input['thumbsniper_advanced_thumbnails_elements_value'][$counter] );
			}
			$counter++;
		}

		$key = $input['thumbsniper_advanced_thumbnails_newelement_key'];
		$value = $input['thumbsniper_advanced_thumbnails_newelement_value'];

		if( !empty($key) && !empty($value) ) 
		{
			$elements[] = array( $key => $value );
		}

		if( count($elements) > 0 )
		{
			$valid['thumbsniper_advanced_thumbnails_elements'] = $elements;
		}

		return $valid;
	}



	function advanced_thumbnails_settings_elements()
	{
?>

		<p>Premium elements extend basic thumbnails by adding additional HTML code to their bubble tips. Running examples of this feature can be found on <a href="http://thumbsniper.com" target="_blank">thumbsniper.com</a>.<br/><strong>As this is the first released version of this feature, your feedback is required to make it more powerful and robust.</strong></p>
		<ol>
			<li>Every premium set consists of an identifier and custom HTML code (or plain text). To add a set, just fill the empty fields at the bottom. With each set, new empty fields appear to create more sets. To delete a set, you'll just have to clear these fields.</li>
			<li>To assign a set to a specific hyperlink, you have to add the CSS class "thumbsniperpremium". The second task is to add a new attribute wich is 'premiumid="&lt;myid&gt;". Here's an example:<br/>
				<p>&lt;a href="http://thumbsniper.com" <strong>class="thumbsniperpremium" premiumid="demo1"</strong>&gt;thumbsniper.com&lt;/a&gt;</p>
			</li>
		</ol>
		<br>
		<table width="100%">
			<?php $this->thumbsniper_elements(); ?>
		</table>

<?php
	} // function



	function thumbsniper_elements($args)
	{
		$elements = $this->get_advanced_thumbnails_setting('thumbsniper_advanced_thumbnails_elements');
		$counter = 1;
?>

		<tr>
			<td>
<!--
				<label for="thumbsniper_general_settings[thumbsniper_preview]">
					<?php echo __("Preview type", "thumbsniper"); ?>
				</label>
-->
			</td>
			<td>

<?php
			foreach($elements as $element) {
				foreach($element as $key => $value) {
?>

					<input id="thumbsniper_elements_key<?php echo $counter; ?>" type="text" 
						name="thumbsniper_advanced_thumbnails_settings[thumbsniper_advanced_thumbnails_elements_key][]" value="<?php echo $key; ?>">
					<textarea id="thumbsniper_elements_value<?php echo $counter; ?>" name="thumbsniper_advanced_thumbnails_settings[thumbsniper_advanced_thumbnails_elements_value][]" 
						rows="6" class="large-text code"><?php echo esc_textarea($value); ?></textarea><br/><br/>

<?php
				}
			}
?>

				<input type="text" size="10" name="thumbsniper_advanced_thumbnails_settings[thumbsniper_advanced_thumbnails_newelement_key]" value="">
				<textarea name="thumbsniper_advanced_thumbnails_settings[thumbsniper_advanced_thumbnails_newelement_value]" rows="6" class="large-text code"></textarea>
			</td>
		</tr>

<?php
	}


} // class

?>
